﻿using System;
using System.Collections.Generic;
using System.Data.Services;
using System.Data.Services.Common;
using System.Linq;
using System.ServiceModel.Web;
using System.Web;
using System.Linq.Expressions;

namespace NorthwindService
{
    public class NorthwindService : DataService< NorthwindEntities >
    {
        // This method is called only once to initialize service-wide policies.
        public static void InitializeService(DataServiceConfiguration config)
        {
            // TODO: set rules to indicate which entity sets and service operations are visible, updatable, etc.
            // Examples:
            //config.SetEntitySetAccessRule("*", EntitySetRights.All);
            config.SetEntitySetAccessRule("Customers", EntitySetRights.AllRead);
            config.SetEntitySetAccessRule("Orders", EntitySetRights.AllRead);
            config.SetEntitySetAccessRule("Order_Details", EntitySetRights.AllRead);
            config.SetEntitySetAccessRule("Products", EntitySetRights.ReadMultiple);

            config.SetEntitySetPageSize("Orders", 5);

            config.DataServiceBehavior.AcceptCountRequests = false;
            config.DataServiceBehavior.AcceptProjectionRequests = false;

            config.MaxExpandCount = 1;

            //config.SetServiceOperationAccessRule("GetOrdersByCity", ServiceOperationRights.AllRead);

            // config.SetServiceOperationAccessRule("MyServiceOperation", ServiceOperationRights.All);
            config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V2;
        }

        // Define a query interceptor for the Orders entity set.
        [QueryInterceptor("Orders")]
        public Expression<Func<Order, bool>> OnQueryOrders()
        {

            return o => o.ShipCountry == "USA";
        }

        [QueryInterceptor("Products")]
        public Expression<Func<Product, bool>> OnQueryProducts()
        {
            if (HttpContext.Current.User.Identity.IsAuthenticated)
            {
                if (HttpContext.Current.User.Identity.Name == "Soul\\Van")
                {
                    return p => p.ProductID > 5;
                }

                return p => p.ProductID == 2;
            }

            return p => p.ProductID == 1;
        }


        // Define a change interceptor for the Products entity set.
        //[ChangeInterceptor("Products")]
        //public void OnChangeProducts(Product product, UpdateOperations operations)
        //{

        //}

        //[WebGet]
        //public IQueryable<Order> GetOrdersByCity(string city)
        //{
        //    if (string.IsNullOrEmpty(city))
        //    {
        //        throw new ArgumentNullException("city",
        //            "You must provide a value for the parameter'city'.");
        //    }

        //    // Get the ObjectContext that is the data source for the service.
        //    NorthwindEntities context = this.CurrentDataSource;

        //    try
        //    {

        //        var selectedOrders = from order in context.Orders.Include("Order_Details")
        //                             where order.Customer.City == city
        //                             select order;

        //        return selectedOrders;
        //    }
        //    catch (Exception ex)
        //    {
        //        throw new ApplicationException(string.Format(
        //            "An error occurred: {0}", ex.Message));
        //    }
        //}
    }

}